#ifndef EDAC_H
#define EDAC_H

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>

int16_t				m,n,length,k,t,d;
uint8_t				p[21];
int					alpha_to[150],index_of[150],g[50];
	
uint8_t						recd[100],data[100],	bb[50];	

uint8_t						numerr,errpos[70],decerror;

#define edac_data_size 112 //56 for 512B sector		// number of elements stored.
#define edac_cache_size 10	

#define edac_data_free_bit 53

#define edac_encoded_data_element_size 67
#define edac_data_element_size 53
#define edac_data_address_bit 52
#define edac_encoded_address_bit 66

struct StorageElement{
	uint32_t data0;
	uint32_t data1;
	uint8_t data2;
};

struct EncodedElement{
	uint8_t encoded_data[edac_encoded_data_element_size];
};


struct DataElement{
	uint8_t data[edac_data_element_size];
};

uint8_t						errors[edac_data_size][5];

uint8_t						data_input[100];

void edac_init(void);

void edac_read_p(void);

void edac_generate_gf(void);

void edac_gen_poly(void);

void edac_encode_bch(void); 

void edac_decode_bch(void);

void edac_gererate_errors(void);

#endif // EDAC_H